*****************************************************
*****************************************************
*                        XPC48X                     *
*          conversion de caractres accentus       *
*            PC -> HP48   ou  HP48 -> PC            *
*  cration : 22/02/94       Auteur : Guy Toublanc  *
*  syntaxe :                                        *
*             niveau 1 : chane  traiter           *
*****************************************************
*****************************************************

::

 CK1NoBlame CK&DISPATCH1 str
 ::
  $ "\eb\e2\ea\e9\e0\e8\ef\ee\f4\f9\fb\e7"
  $ "\89\83\88\82\85\8a\8b\8c\93\97\96\87"
  $ "\8DPC: 0  \8DHP48: 1"
  NULL$ xINPUT xOBJ>
  %0> ?SWAP

*****************************************************
*****************************************************
*                        MAP                        *
*           (cksum: # 33FAh  148.5 octets)          *
*      remplacement des caractres d'une chane     *
* Cration: 10/02/94  Adaptation par Guy Toublanc   *
*                     du Lex Maplex (JPC 46 7/87)   *
*                     pour HP71 de Tapani Tarvanen *
*                                                   *
* Syntaxe: niveau 3 <- str0 : chane  traiter      *
*          niveau 2 <- str1 : chane des caractres *
*                              remplacer           *
*          niveau 1 <- str2 : chane des caractres *
*                             de remplacement       *
*                             correspondant  str1  *
*****************************************************
*****************************************************



  ROT TOTEMPOB
CODE

*****************************************************
* aprs vrification de la prsence de 3 niveaux de *
* chanes nous avons :                              *
*                      niveau 3 <- str2             *
*                      niveau 2 <- str1             *
*                      niveau 1 <- str0 recre     *
* puis nous crons une chane vecteur strv de 256   *
* caractres de valeurs 0  255 qui sera aussi une  *
* table de positionnement de caractres             *
*****************************************************

       gosbvl =SAVPTR       * sauve les pointeurs
       lc(5)  512           * longueur en quartets
       gosbvl =MAKE$N       * R0 := adr. strv cre
*                             D0 @ donnes de strv
       cd0ex
       r1=c                 * sauve adr. donnes strv
       d0=c                 * @ donnes strv
       c=0    b             * pour initialiser strv

init   dat0=c b             * boucle d'initialisation
       d0=d0+ 2             * de strv avec caractres
       c=c+1  b             * de valeurs 0  255
       gonc   init          * pour la future table

       gosbvl =GETPTR       * restitue les pointeurs
       gosbvl =GetStrLenStk * C(A) := len str0
*                             D1 @ donnes de str0
       c=c-1  a             *
       goc    bad0          * refus si chane nulle
       rstk=c               * sauve (len - 1) de str0
       cd1ex                *
       rstk=c               * sauve adr. donnes str0
       gosbvl =GETPTR       * restitue les pointeurs 
       d1=d1+ 5             * @ niveau 2 : str2
       gosbvl =GetStrLenStk * mme principes str0
       rstk=c               * sauve len de str2
       cd1ex                *
       rstk=c               * sauve adr. donnes str2
       gosbvl =GETPTR       * restitue les pointeurs
       d1=d1+ 10            * @ niveau 3 : str1
       gosbvl =GetStrLenStk * mme principes str0 
       b=c    a             * sauve len de str1
       c=rstk               *
       d0=c                 * @ donnes str2
       c=rstk               *
       a=c    a             * len de str2
       c=r1                 * 
       d=c    a             * adresse table
       ?a=b   a             * len str2 = len str1 ?
       goyes  ok            *
bad2   c=rstk               * si non dpile et erreur
       c=rstk               *
bad0   lchex  00203         * pour bad argument value
       govlng =GPErrjmpC    * sortie avec ce message   
ok     b=b-1  a             * 
       goc    bad2          * erreur si str1 et str2
*                             de longueur nulle
tabl   c=0    a             * boucle de vectorisation
       c=dat1 b             * valeur carac. n de str1
       c=c+c  x             * transforme en offset
       c=c+d  a             * adresse position j
       cd1ex                * @ position j dans table
       a=dat0 b             * caractre n de str2
       dat1=a b             * charge en position j
       cd1ex                * restaure D1
       d1=d1+ 2             * @ caract. n + 1 de str1
       d0=d0+ 2             * @ caract. n + 1 de str2
decr   b=b-1  a             * compteur car. str1 et str2
       gonc   tabl          *

       c=rstk               *
       d1=c                 * @ donnes str0
       c=rstk               *
       a=c    a             * (len - 1) de str0

loop   c=0    a             * boucle de traduction
       c=dat1 b             * caractre n de str0
       c=c+c  x             * transforme en offset
       c=c+d  a             * adresse dans table
       d0=c                 * @ position j dans table
       c=dat0 b             * caract. de remplacement
*                             ou non suivant caract.
*                             n de str0
       dat1=c b             * charge str0
       d1=d1+ 2             * @ caract. n + 1 de str0
       a=a-1  a             * actualise compteur
       gonc   loop          *

       govlng =GETPTRLOOP   * restaure pointeurs et
*                             retour au RPL
ENDCODE
  UNROT2DROP               
* drop sur str1 et str2
 ;
;
