        DOSSEG
code    segment para 'CODE'
        assume cs:code
        ORG    100h

start:  jmp    strt        ;premire inst. excute

K_ESC   EQU    001Bh       ;definition des codes de 
K_ENTER EQU    000Dh       ;  touches
K_UP    EQU    4800h
K_DOWN  EQU    5000h

Not_95  DB     "This program runs only on an HP95LX"
        DB     13,10,"$"

Dispstr DB     "HP95LX Contrast control",13,10,10
        DB     "Initial contrast = "
D_init  DB     "XX",13,10
        DB     "Current contrast = "
D_curr  DB     "XX",13,10,10
        DB     "Contrast :  UP = +1   DOWN = -1 ",13,10
        DB     "ESC = Exit without Change",13,10
        DB     "ENTER = Exit with Change",13,10,"$"

C_init  DB     (?)         ;Contraste initial
C_curr  DB     (?)         ;Contraste courant

strt:   mov    bx,cs       ;ncessaire pour la
        mov    ds,bx       ; fonction 09h

        mov    ax,4dd4h    ;vrification d'excution
        int    15h         ; sur HP95
        cmp    bx,'HP'
        jne    nok_95
        cmp    ch,1
        je     ok_95       ;si hp95, on passe
nok_95: mov    dx,OFFSET Not_95
        mov    ah,09h
        int    21h
        jmp    exit        ;sortie du programme

ok_95:  call   rd_cont     ;acquisition contraste
        mov    [C_init],al ;stockage dans variables
        mov    [C_curr],al
        call   htoa        ;conversion en texte
        mov    WORD PTR [D_init],ax ;sto dans texte
boucle: mov    WORD PTR [D_curr],ax
        mov    dx,OFFSET Dispstr
        mov    ah,09h
        int    21h         ;affichage du texte

wait_key :
        mov    ah,0
        int    16h         ;Lecture du clavier
        cmp    al,0        ;code tendu ?
        je     ok
        xor    ah,ah       ;on efface le scan code
ok:     cmp    ax,K_ENTER  ;touche ENTER ?
        je     exit        ; oui, sortie
        cmp    ax,K_ESC    ;touche ESC ?
        je     c_esc       ; oui, traitement ESC
        cmp    ax,K_UP     ;touche UP ?
        je     c_up        ; oui, traitement UP
        cmp    ax,K_DOWN   ;touche DOWN ?
        je     c_down      ; oui, traitement DOWN
        jmp    wait_key    ;autres cas, on boucle

c_up:   cmp    BYTE PTR [C_curr],15 
        je     ovrflw      ;si contraste = 15,
                           ; pas d'incrmentation
        inc    BYTE PTR [C_curr] ;incrmente contrast
ovrflw: jmp    redisp

c_down: cmp    BYTE PTR [C_curr],0
        je     redisp      ;si contraste = 0,
                           ; pas de dcrmentation
        dec    BYTE PTR [C_curr] ;dcrmente contrast
redisp: mov    al,[C_curr] ;lecture contraste
        call   st_cont     ;correction contraste
        mov    ah,03h      ;lecture position du 
                           ; curseur
        mov    bh,0
        int    10h
        sub    dh,8        ;calcul ligne dbut texte
        mov    ah,2        ;repositionnement curseur
        mov    bh,0
        int    10h       
        mov    al,[C_curr] ;lecture contraste
        call   htoa        ;conversion en texte
        jmp    boucle      ;retourne vers affichage

c_esc:  mov    al,[C_init] ;lecture contraste init.
        call   st_cont     ;on remet tout en ordre
exit:   mov    ah,4ch      ;retour au DOS
        int    21h

rd_cont PROC NEAR          ;lecture du contraste
        mov    ax,4701h
        int    15h
        ret
rd_cont ENDP

st_cont PROC NEAR          ;correction du contraste
        mov    bl,al
        xor    bh,bh
        mov    ax,4700h
        int    15h
        ret
st_cont ENDP

htoa    PROC NEAR          ;conversion en ASCII
        aam
        add    ax,3030h
        cmp    ah,'0'
        jne    htoa_1
        mov    ah,' '
htoa_1: xchg   ah,al
        ret 
htoa    ENDP

Code    ends
        END    start       ;fin du programme
