; SCRN100.COM
; Written by Jacques Belin

        DOSSEG
code    segment para 'CODE'
        assume cs:code,ds:code
        ORG   100h

start:  jmp   main      ; saut sur premire inst.

                        ; message d'erreur
usage   DB    "usage :  scrn100 { 8 | 6 | 4 }"
        DB    13,10,10,"$"

Not_100 DB     "This program runs only on an HP100LX"
        DB     13,10,"$"

main:   mov   ax,4dd4h  ;vrification d'excution
        int   15h       ; sur un palmtop HP
        cmp   bx,'HP'
        jne   main_2
        cmp   ch,1
        je    main_3     ;si hp100, on passe
main_2: mov   dx,OFFSET Not_100
        jmp   err02
        ;----------


main_3: mov   si,128    ; SI ^ sur longueur param
        lodsb
        cmp   al,1      ; si pas de paramtres..
        jbe   error     ; ... erreur

        xor   ch,ch     ; CX = nbre caractres param
        mov   cl,al

                        ; SAUT DES ESPACES DU PARAMETRE
main_4: lodsb           ; lecture caractre param
        cmp   al," "    ; si caract # espace..
        jne   main_5    ; passe  la suite de l'analyse
        dec   cx        ; si encore des espaces..
        jnz   main_4    ; ..on boucle
        jmp   error     ; ..sinon erreur
        ;---------

                        ; ANALYSE SIMPLIFIEE PARAMETRE
                        ; (sur premier caractre)
main_5: cmp   al,"8"    ; si parametre = "8"
        jne   main_6    ; non, on passe
        mov   dl,03h    ; sinon, dl = mode...
        jmp   main_8    ; .. et on va plus bas
        ;---------

main_6: cmp   al,"6"    ; si parametre = "6"
        jne   main_7    ; non, on passe
        mov   dl,80h    ; sinon, dl = mode...
        jmp   main_8    ; .. et on va plus bas
        ;---------

main_7: cmp   al,"4"    ; si parametre # "4"..
        jne   error     ; ..erreur
        mov   dl,84h    ; sinon, dl = mode...

main_8: xor   ah,ah     ; AH=0 (fonction SET MODE}
        mov   al,dl     ; AL = Mode vido
        int   10h       ; activation fonction vido
        jmp   exit      ; ...et on sort.
        ;---------

                        ; affichage message d'erreur
error:  mov   dx,OFFSET usage 
err02:  mov   ah,09h
        int   21h

exit:   mov   ah,4ch                 ; retour au DOS
        int   21h

Code    ends
        END   start          ; That's All Folks !

