BEGINCODE

; This program searches a hexadecimal string in memory
;
; Arguments : 2: Starting address of search
;             1: string
;
; Returns   : 1: Address of hexadecimal string if found
;             1: #0h if not found
;
; The program stops after the address #FFFFh
;
; Example : 2: #A00h  1: "AC1"   FIND


	include	addr-48.as

	nibhex	begin_prog
	nibhex	fde81
	nibhex	11920
	nibhex	3b000
	nibhex	begin_code
	rel(5)	fincode
	gosbvl	save_reg
	a=dat1	a
	d0=a
	d0=d0+5
	c=0	w
	c=dat0	a
	csrb
	c=c-1	a
	c=c-1	a
	b=c	a
	?c!=0	a
	goyes	ok1
	goto	fin
ok1	d0=d0+5
	ad0ex
	d0=a
	r0=a
	d1=d1+5
	c=dat1	a
	d1=c
	d1=d1+10
	cd1ex
	r1=c
	d1=a
	c=b	a
	d=c	a
loop1	a=dat0	b
	lchex	#30
	a=a-c	b
	lchex	#0a
	?c>a	b
	goyes	digit
	lchex	#07
	a=a-c	b
digit	dat1=a	p
	d1=d1+1
	d0=d0+2
	d=d-1	a
	?d!=0	a
	goyes	loop1
	a=r0
	d0=a
	c=dat0	p
	d=c	p
	a=r1
	d1=a
	a=dat1	a
	d1=a
loop2	c=dat1	p
	?c=d	p
	goyes	test
increm	d1=d1+1
	gonc	loop2
found	cd1ex
	a=r1
	d1=a
	dat1=c	a
fin	gosbvl	load_reg
	d1=d1+5
	d=d+1	a
	a=dat0	a
	d0=d0+5
	pc=(a)
test	ad1ex
	d1=a	
	r2=a
	c=b	a
	d=c	a
loop3	d=d-1	a
	?d!=0	a
	goyes	cont
	a=r2
	d1=a
	goto	found
cont	d1=d1+1
	goc	found
	d0=d0+1
	c=dat1	p
	a=dat0	p
	?a=c	p
        goyes   loop3
	a=r0
	d0=a	
	c=dat0	p
	d=c	p
	a=r2
	d1=a
	goto	increm
fincode	nibhex	end_prog


	ENDCODE
