
*****************************************************
*                      D4COLOR                      *
*             153 octets   cksum # D219h            *
*                                                   *
* programme d'affichage en trois ou quatre nuances  *
* de gris d'un objet graphique compos de 2 ou 3    *
* parties correspondant  2 ou 3 crans.             *
* La succession des affichages crant ces nuances   *
* de gris.                                          *
*     Auteur : Guy Toublanc         le 23/4/94      *
*                                                   *
* argument : 1 objet graphique spcifique pour ces  *
*            affichages                             *
*                                                   *
* compatible HP48G/GX et HP48S/SX                   *
*****************************************************

:: CK1NoBlame CK&DISPATCH1 TWELVE
  :: TURNMENUOFF
CODE
=savleftmargin   EQU #00100
=adrptrbitmap    EQU #00120
=savrightmargin  EQU #00125
=savvideosynchro EQU #00129
=savVDISP1       EQU #01F79
=DISP1CTLs       EQU #7050E   * pour HP48S/SX
=VDISP1s         EQU #7055B   * pour HP48S/SX
=DISP1CTLg       EQU #8068D   * pour HP48G/GX

         gosbvl   =PopASavptr
         gosbvl   =DisableIntr * interdit les inter.
         d0=a               * @ le grob
         d0=d0+   10        * @ la hauteur du grob
         st=0     0         * pour plus de 2 crans
         a=dat0   a         * hauteur grob
         lc(5)    128       * hauteur 2 crans
         ?a>c     a         * plus de 2 crans ?
         goyes    3scr      * oui alors 3scr
         st=1     0         * sinon pour 2 crans
3scr     d0=d0+   10        * @ donnes du grob
         ad0ex              * adresse 1er cran
         b=a      a         * adr. 1er cran -> b(a)
         lc(3)    (34*64)   * offset entre crans
         a=a+c    a         * adresse 2ime cran
         c=a+c    a         * adresse 3ime cran
         d=c      a         * sauvegarde
         d0=(5)   =savleftmargin
         c=dat0   s
         ?abit=0  0         * adresse paire ?
         goyes    nop       * oui on saute
         lchex    c
         dat0=c   1         * marge  4
         d0=(2)   =savrightmargin
         c=0      a
         c=c-1    a         * pour # FFFh (-1)
         dat0=c   x         * marge  -1
nop      d1=(5)   =adrptrbitmap
         d0=(2)   =savvideosynchro
loop     c=b      a         * adresse 1er cran
         gosub    dispscr   * affichage 1er cran
         c=a      a         * adresse 2ime cran
         gosub    dispscr   * affichage 2ime cran
         ?st=0    0         * 3ime cran ?
         goyes    3Scr      * oui pour affichage
         lchex    800       * pour une temporisation
waitloop c=c-1    x         * boucle d'attente
         gonc     waitloop
         goc      ?out      * on saute affich. 3e cr
3Scr     c=d      a         * adresse 3ime cran
         gosub   dispscr    * affichage 3ime cran
?out     gosbvl   #01eec    * out=c c=in
         ?cbit=0  15        * ? pas d'appui sur ATTN
         goyes    loop      * oui on reboucle
out      d0=(2)   =savleftmargin
         dat0=c   s         * restaure marge gauche
         lc(5)    =VDISP1s
         d1=(5)   =savVDISP1
         a=dat1   a
         d1=(5)   =DISP1CTLs
         ?a=c     a         * hp48s/sx ?
         goyes    restore   * oui on garde d1
         d1=(5)   =DISP1CTLg * pour hp48g/gx
restore  c=dat1   8         * rcupre val. bitmap
         d0=(2)   =adrptrbitmap
         dat0=c   8         * restaure bitmap initial
         gosbvl   =AllowIntr * autorise les interrupt
         govlng   =GETPTRLOOP * retour rpl

dispscr  dat1=c   a         * charge adresse cran n
vsync1   c=dat0   1         * bit 1 de la synchro vid
         ?cbit=1  1         * toujours  1 ?
         goyes    vsync1    * oui on attemd encore
vsync2   c=dat0   1         * aprs passage  1
         ?cbit=0  1         * est-il repass  0 ?
         goyes    vsync2    * si oui on reboucle
         rtn
ENDCODE
 ;
;
